//+------------------------------------------------------------------+
//|                                                 StochcrossEA.mq4 |
//|                      Copyright  2009, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#property copyright "Copyright  2009, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net"

extern double lots = 0.1;
extern int RSI_setting = 14;
extern int upline      = 52;
extern int dnline      = 48;

int magic = 88888;
//+------------------------------------------------------------------+
int init()
    {
      return(0);
    }
//+------------------------------------------------------------------+
int deinit()
    {
      return(0);
    }
//+------------------------------------------------------------------+
int start()
    {
       double rsinya;
       int    total, i, mmagic, ticket;
       bool   result, opbuy, opsell;
       
       rsinya = iCustom(NULL, 0, "RSI",RSI_setting,0,1);
       
       if(rsinya > upline)
         {
            opbuy  = true;
            total = OrdersTotal();
            if(total > 0)
              {
                 i      = total - 1;
                 mmagic = 0;
                 while(mmagic != magic && i >= 0)
                      {
                         result = OrderSelect(i,SELECT_BY_POS,MODE_TRADES);
                         if(!result) return(0);
                         if(OrderSymbol() == Symbol() && OrderMagicNumber() == magic)
                           {
                              mmagic = magic;
                              if(OrderType() == OP_SELL)
                                {
                                   result = OrderClose(OrderTicket(),OrderLots(),Ask,3,Violet);
                                   if(!result) return(0);
                                }
                              else
                                {
                                   return(0);
                                }                                       
                           }
                      }
              }
            ticket=OrderSend(Symbol(),OP_BUY,lots,Ask,3,0,0,"EA",magic,0,Green);
         }                     
       else
         {
            if(rsinya < dnline)                        
              {                 
                 opsell = true;
                 total  = OrdersTotal();
                 if(total > 0)
                   {
                      i      = total - 1;
                      mmagic = 0;
                      while(mmagic != magic && i >= 0)
                           {
                              result = OrderSelect(i,SELECT_BY_POS,MODE_TRADES);
                              if(!result) return(0);
                              if(OrderSymbol() == Symbol() && OrderMagicNumber() == magic)
                                {
                                   mmagic = magic;
                                   if(OrderType() == OP_BUY)
                                     {
                                        result = OrderClose(OrderTicket(),OrderLots(),
                                                            Bid,3,Violet);
                                        if(!result) return(0);
                                     }
                                   else
                                     {
                                        return(0);
                                     }
                                }
                           }
                   }
                 OrderSend(Symbol(),OP_SELL,lots,Bid,3,0,0,"EA",magic,0,Blue);
              }
         }
       return(0);
    }
//+------------------------------------------------------------------+